/*
 * HttpRequest.java
 *
 * Created on 2004/08/16, 13:57
 */

package net.sourceforge.shingetsu.server;

import java.util.Map;
import java.util.Enumeration;

import java.lang.NumberFormatException;
import java.lang.IllegalArgumentException;

/**
 * @̃NXHTTPNGXgJvZANGXg烌X|X̂߂
 * KvƂȂ@\񋟂܂B
 * @author stokesia
 */
public interface HttpRequest {
    /**
     * NGXg̑M̃zXgl[擾܂B
     * @return String`̃zXgl[
     */    
    public String getRemoteHost();
    /**
     * NGXg̑M̃zXgAhX擾܂B
     * @return String`̃zXgAhX
     */    
    public String getHostAddress();
    /**
     * ̃NGXgHTTPo[W擾܂B
     * @return NGXgHTTPo[W
     */    
    public String getProtocolVersion();
    /**
     * ̃NGXg̃\bh擾܂B
     * @return NGXg̃\bh
     */    
    public String getMethod();
    /**
     * ̃NGXg̃NG[擾܂B
     * @return NGXgNG[
     */    
    public String getQuery();
    /**
     * ̃NGXg̃pX擾܂B
     * @return NGXg̃pX
     */    
    public String getPath();
    /**
     * NGXg̃p[^擾܂B
     * @param name NGXgp[^̖O
     * @return NGXgp[^̒lA݂Ȃnull
     */    
    public String getParameter(String name);
    /**
     * ̃NGXg}`p[g̃NGXgǂ擾܂B
     * @return }`p[g̃NGXgłtrue
     */    
    public boolean isMultipartRequest();
    /**
     * }`p[g܂ރNGXg̎w肵p[g擾܂B擾p[g̃tB[
     * hɃANZXɂMapNXIuWFNgɎ擾wb_[̖Ow
     * 擾܂BtH[̃p[^ConfigNXŒ`ĂGR[fB
     * OŃGR[fBOĂ܂Bt@CAbv[hĂꍇ̓t@C
     * ̃p[g̒lISO-8859-1ŃGR[fBOĂ܂BJ҂ISO-8859-1
     * oCgzɕϊA]̏s܂B
     * @param name wb_[̖O
     * @return p[gMapNX̃IuWFNgA݂Ȃnull
     */    
    public Map getPart(String name);
    /**
     * NGXg̃t@C擾܂B
     * @return NGXgFileIuWFNg
     */    
    public String getFile();
    /**
     * wb_[̒l擾܂B
     * @param name wb_[̖O
     * @return wb_[̒lAwb_[l݂Ȃꍇnull
     */    
    public String getHeader(String name);
    /**
     * t̃wb_[擾܂B
     * @param name wb_[̖O
     * @return twb_[̒lAwb_[l݂Ȃꍇnull
     * @throws IllegalArgumentException sȏꍇ
     */    
    public String getDateHeader(String name) throws IllegalArgumentException;
    /**
     * wb_[̒ll̃wb_[擾܂B
     * @param name wb_[̖O
     * @return wb_[̒lAwb_[l݂Ȃꍇnull
     * @throws NumberFormatException ̃tH[}bgsȏꍇ
     */    
    public String getIntHeader(String name) throws NumberFormatException;
    /**
     * wb_[̖O̗񋓎q擾܂B
     * @return  wb_[̖O̗񋓎q
     */    
    public Enumeration getHeaderNames();
    /**
     * wb_[̒l̗񋓎q擾܂B
     * @return wb_[̗񋓎q
     */    
    public Enumeration getHeaders();
}
