/*
 * ErrorCGI.java
 *
 * Created on 2004/08/24, 0:45
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.PrintWriter;

import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.server.cgi.CGI;
import net.sourceforge.shingetsu.util.Config;

import java.io.IOException;

import net.sourceforge.shingetsu.server.HttpProtocolException;

/**
 * G[\CGINXłB
 * @author stokesia
 */
public class ErrorCGI {
    
    private Config config = Config.getInstance();
    private HttpProtocolException exception = null;
    
    /** Creates a new instance of ErrorCGI */
    public ErrorCGI() {
    }
    
    public ErrorCGI(HttpProtocolException exception) {
        this.exception = exception;
    }
    
    public void excecute(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        int statusCode = exception.getStatusCode();
        String detailedMessage = exception.getMessage();
        String errorMessage = HttpServer.getReasonPhrase(statusCode);
        
        PrintWriter writer = response.getWriter();
        
        writer.println("<html>");
        writer.println("<title>" + statusCode + " " + errorMessage + "</title>");
        writer.println("<body>");
        writer.println("<h1>" + errorMessage + "</h1>");
        
        writer.println(detailedMessage);
        
        writer.println("<hr>");
        writer.println(config.getUserAgent() + " Port " + config.getPort());
        writer.println("</body>");
        writer.println("</html>");
        
        writer.flush();
        writer.close();
    }

}
